unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ShellApi, Menus, ExtCtrls, ActnList, StdCtrls, ComCtrls, Buttons, REGISTRY;

type
  TwndIconic = class(TForm)
    actAction: TActionList;
    actAcercaDe: TAction;
    actAyuda: TAction;
    actMinimizar: TAction;
    actSalir: TAction;
    PopupMenu1: TPopupMenu;
    Acercade1: TMenuItem;
    Ayuda1: TMenuItem;
    Minimizar1: TMenuItem;
    Salir1: TMenuItem;
    actConfiguracion: TAction;
    N1: TMenuItem;
    Configuracin1: TMenuItem;
    N2: TMenuItem;
    txtEuro: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    txtPta: TEdit;
    procedure FormDestroy(Sender: TObject);
    procedure actAcercaDeExecute(Sender: TObject);
    procedure actAyudaExecute(Sender: TObject);
    procedure actMinimizarExecute(Sender: TObject);
    procedure actSalirExecute(Sender: TObject);
    procedure actConfiguracionExecute(Sender: TObject);
    procedure txtEuroChange(Sender: TObject);
    procedure txtPtaChange(Sender: TObject);
    procedure txtEuroEnter(Sender: TObject);
    procedure txtPtaEnter(Sender: TObject);
    procedure RButtonUp;
    procedure LButtonDblClk;
    procedure txtEuroKeyPress(Sender: TObject; var Key: Char);
    procedure txtPtaKeyPress(Sender: TObject; var Key: Char);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure Filtro(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
  protected
    procedure WndProc(var Msg: TMessage); override;
  public
    procedure NotifyTray(Command: Word; const Hint: string);
  private
    euros : boolean;
    impEuros : double;
    impPtas : double;
    FTrayMessage: Cardinal;
  end;
var
  wndIconic: TwndIconic;

implementation

uses About;

{$R *.DFM}

resourcestring
  STrayMessage = 'EuroConversor';

procedure TwndIconic.NotifyTray(Command: Word; const Hint: string);
var
  Data: TNotifyIconData;
begin
  Data.cbSize := SizeOf(Data);
  Data.uID := 0;
  Data.uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;
  Data.Wnd := Self.Handle;
  Data.uCallbackMessage := FTrayMessage;
  Data.hIcon := Application.Icon.Handle;
  StrLCopy(Data.szTip, PChar(Hint), SizeOf(Data.szTip));
  Shell_NotifyIcon(Command, @Data);
end;

procedure TwndIconic.WndProc(var Msg: TMessage);
begin
  if Msg.Msg = FTrayMessage then
    case Msg.LParam of
      WM_RBUTTONUP: RButtonUp;
      WM_LBUTTONDBLCLK: LButtonDblClk;
    end
  else
    inherited WndProc(Msg);
end;

procedure TwndIconic.LButtonDblClk;
begin
  actConfiguracionExecute(nil);
end;

procedure TwndIconic.RButtonUp;
var
  Pt: TPoint;
begin
  GetCursorPos(Pt);
  SetForegroundWindow(Application.Handle);
  Application.ProcessMessages;
  PopupMenu1.Popup(Pt.X, Pt.Y);
end;

procedure TwndIconic.FormDestroy(Sender: TObject);
begin
  NotifyTray(NIM_DELETE, '');
end;

procedure TwndIconic.actAcercaDeExecute(Sender: TObject);
begin
  with Twndabout.Create(nil) do
  try
    ShowModal;
  finally
    Free;
  end;
end;

procedure TwndIconic.actAyudaExecute(Sender: TObject);
begin
   messagedlg ('Teclas: ' + chr(13) + chr(13) +
       '      M -> minimizar conversor.' + chr(13) +
       '      S -> cerrar conversor (Escape).' + chr(13) +
       '      D -> acerca del conversor.' + chr(13) +
       '      A -> muestra esta ayuda.' + chr (13) + chr (13) +
       '   Para mostrar el men pulse el botn derecho del ratn sobre la ventana.'
       + chr (13) + chr (13) +
       '   Para ver todos los decimales del valor pase el cursor del ratn por encima del nmero.'
       + chr (13) + chr (13) +
       '   Una vez minimizada la aplicacin puede ver la ltima conversin pasando el cursor del ratn por encima del icono del conversor (en la barra de tareas de Windows).',
       mtinformation, [mbok],0);
end;

procedure TwndIconic.actMinimizarExecute(Sender: TObject);
begin
  hide;
  actMinimizar.visible := false;
  actConfiguracion.visible := true;
  Application.ShowMainForm := False;
  ShowWindow(Application.Handle, SW_HIDE);
  FTrayMessage := RegisterWindowMessage(PChar(STrayMessage));
  if (txteuro.text = '') or (txtpta.text = '') then
    NotifyTray(NIM_ADD, 'Conversor (por AlonsoJPD)')
  else
    NotifyTray(NIM_ADD, ' ' + txteuro.Text + ' ' + chr(10) + chr(13) + ' ' + txtpta.Text + ' Pta')
end;


procedure TwndIconic.actSalirExecute(Sender: TObject);
begin
  close;
end;

procedure TwndIconic.actConfiguracionExecute(Sender: TObject);
begin
  show;
  actMinimizar.Visible := true;
  actConfiguracion.Visible := false;
  NotifyTray(NIM_DELETE, '');  
end;


procedure TwndIconic.Filtro(Sender: TObject);
var
  i : integer;
  aux, aux2, cad : string;
begin
  cad := '0123456789,.'; // Solo se admiten estos caracteres
  aux2:='';
  with (Sender as TEdit) do
  begin
    aux:=text;
    for i:=1 to length(aux) do
      if pos(aux[i],cad)>0 then aux2:=aux2+aux[i];
        text:=aux2;
      SelStart:=length(aux2);
  end;
end;

procedure TwndIconic.txtEuroChange(Sender: TObject);
begin
  Filtro(sender);
  if euros then
  begin
    try
      impptas := strtofloat(txtEuro.text) * 166.386;
      txtPta.Text := formatfloat('###,###,###,##0;-###,###,###,##0;0',
          impptas);
      impEuros := strtofloat(txtEuro.Text);
    except
      impEuros := 0;
      impptas := 0;
      txtPta.text := '';
      exit;
    end;
  end;
  txtPta.Hint := floattostr(impPtas);
  txtEuro.Hint := floattostr(impEuros);
end;

procedure TwndIconic.txtPtaChange(Sender: TObject);
begin
  Filtro(sender);
  if not euros then
  begin
    try
      impEuros := strtofloat(txtPta.text)/166.386;
      txtEuro.Text := formatfloat('###,###,###,##0.00;-###,###,###,##0.00;0',
          impEuros);
      impPtas := strtofloat(txtPta.Text);
    except
      impPtas := 0;
      impeuros := 0;
      txteuro.text := '';
      exit;
    end;
  end;

  txtEuro.Hint := floattostr(impeuros);
  txtPta.Hint := floattostr(impPtas);
end;


procedure TwndIconic.txtEuroEnter(Sender: TObject);
begin
  euros := true;
end;

procedure TwndIconic.txtPtaEnter(Sender: TObject);
begin
  euros := false;
end;

procedure TwndIconic.txtEuroKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
    txtPta.SetFocus;
  if key = '.' then
    key := ',';
end;


procedure TwndIconic.txtPtaKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
    txtEuro.SetFocus;
  if key = '.' then
    key := ',';
end;

procedure TwndIconic.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #27 then
    close;
  if (key = 'm') or (key = 'M') then
    actMinimizarExecute(nil);
end;

procedure TwndIconic.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   if Key in [VK_UP,VK_DOWN] then
   begin
     if Key = VK_UP then Perform(WM_NEXTDLGCTL, 1, 0)
                    else Perform(WM_NEXTDLGCTL, 0, 0);
     Key:=0;
   end;
end;

procedure TwndIconic.FormShow(Sender: TObject);
begin
  ShowWindow(application.Handle, SW_HIDE)
end;

procedure TwndIconic.FormClose(Sender: TObject; var Action: TCloseAction);
var
  Registry: TRegistry;
begin
  Registry := TRegistry.Create;
  try
    Registry.RootKey := HKEY_CURRENT_USER;
    Registry.OpenKey ('Software\AJPD\EuroConversor', True);
    Registry.WriteInteger('Posicion Y', wndIconic.Top);
    Registry.WriteInteger('Posicion X', wndIconic.Left);    
    Registry.WriteString('Valor Euros', txtEuro.Text);
    Registry.WriteString('Valor Ptas', txtPta.Text);
    Registry.CloseKey;
  finally
    Registry.Free;
  end;
end;


procedure TwndIconic.FormActivate(Sender: TObject);
var
  Registry: TRegistry;
  posX, posY : integer;
begin
  Registry := TRegistry.Create;
  try
    Registry.RootKey := HKEY_CURRENT_USER;
    posx := 35000;
    posy := 35000;
    if Registry.OpenKey ('Software\AJPD\EuroConversor', false) then
    begin
      try
        posX := Registry.ReadInteger('Posicion X');
        posY := Registry.ReadInteger('Posicion Y');
      except
      end;
    end;
    if (posX < Screen.Width) and (posY < Screen.Height) then
      if not (posX = 35000) and not (posY = 35000) then
      begin
        Left := posX;
        Top := posY;
      end;
    Registry.CloseKey;
  finally
    Registry.Free;
  end;
end;

end.
